﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Sinuser extends Sprite
	{
		private var bmp:BitmapData;
		private var angle:uint = 0;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(0.5,3,20);
		private var colors:Array = [0xffffff,0x999999];
		public function Sinuser()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmp = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			addChild(new Bitmap(bmp));
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function buildCycle(target:Sprite,angle:uint):Sprite
		{	
			var point:Sprite = new Sprite();
			point.graphics.beginFill(colors[angle%5],0.3);
			point.graphics.drawRect(0,0,20,Math.random()*90);
			point.graphics.endFill();
			target.addChild(point);
			//point.x = Math.cos(angle*Math.PI/180)*10;
			//point.y = Math.sin(angle*Math.PI/180)*10;
			return point;
		}
		private function enterHandler(e:Event):void
		{
			var basis:Sprite = new Sprite();
			basis.x = stage.stageWidth*Math.random();
			basis.y = stage.stageHeight;
			support.addChild(basis);
			for(var i:uint=0;i<100;i++){
				basis = buildCycle(basis,angle*i);
			}
			var m:Matrix = new Matrix();
			m.rotate(3);
			m.translate(stage.stageWidth+mouseX*3,stage.stageHeight+mouseY*3);
			m.scale(0.3 ,0.4);
			if(angle%40 == 0){
				bmp.applyFilter(bmp,bmp.rect,new Point(0.3,0.3),filterObj); //filtre floue
			}
			bmp.draw(support,m);
			support.removeChildAt(0);
			angle++;
		}
	}
}